<?php
/**
 * ApiV1TagsGroupTag
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * ApiV1TagsGroupTag Class Doc Comment
 *
 * @category Class
 * @description represents a tag
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class ApiV1TagsGroupTag implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = '_api_v1_tags_groupTag';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'name' => 'string',
        'backgroundColor' => 'string',
        'fontColor' => 'string',
        'description' => 'string',
        'image' => 'string',
        'groupTagId' => 'int',
        'groupTag' => 'object',
        'groupTagInheritance' => 'bool',
        'isGroupParent' => 'bool',
        'visibilities' => 'object[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'name' => null,
        'backgroundColor' => null,
        'fontColor' => null,
        'description' => null,
        'image' => null,
        'groupTagId' => null,
        'groupTag' => null,
        'groupTagInheritance' => null,
        'isGroupParent' => null,
        'visibilities' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'name' => 'name',
        'backgroundColor' => 'backgroundColor',
        'fontColor' => 'fontColor',
        'description' => 'description',
        'image' => 'image',
        'groupTagId' => 'groupTagId',
        'groupTag' => 'groupTag',
        'groupTagInheritance' => 'groupTagInheritance',
        'isGroupParent' => 'isGroupParent',
        'visibilities' => 'visibilities'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'name' => 'setName',
        'backgroundColor' => 'setBackgroundColor',
        'fontColor' => 'setFontColor',
        'description' => 'setDescription',
        'image' => 'setImage',
        'groupTagId' => 'setGroupTagId',
        'groupTag' => 'setGroupTag',
        'groupTagInheritance' => 'setGroupTagInheritance',
        'isGroupParent' => 'setIsGroupParent',
        'visibilities' => 'setVisibilities'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'name' => 'getName',
        'backgroundColor' => 'getBackgroundColor',
        'fontColor' => 'getFontColor',
        'description' => 'getDescription',
        'image' => 'getImage',
        'groupTagId' => 'getGroupTagId',
        'groupTag' => 'getGroupTag',
        'groupTagInheritance' => 'getGroupTagInheritance',
        'isGroupParent' => 'getIsGroupParent',
        'visibilities' => 'getVisibilities'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['name'] = $data['name'] ?? null;
        $this->container['backgroundColor'] = $data['backgroundColor'] ?? null;
        $this->container['fontColor'] = $data['fontColor'] ?? null;
        $this->container['description'] = $data['description'] ?? null;
        $this->container['image'] = $data['image'] ?? null;
        $this->container['groupTagId'] = $data['groupTagId'] ?? null;
        $this->container['groupTag'] = $data['groupTag'] ?? null;
        $this->container['groupTagInheritance'] = $data['groupTagInheritance'] ?? null;
        $this->container['isGroupParent'] = $data['isGroupParent'] ?? null;
        $this->container['visibilities'] = $data['visibilities'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name name of the tag
     *
     * @return self
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets backgroundColor
     *
     * @return string|null
     */
    public function getBackgroundColor()
    {
        return $this->container['backgroundColor'];
    }

    /**
     * Sets backgroundColor
     *
     * @param string|null $backgroundColor background color of the tag (in hex, for example FF0000 - max. 6 chars!)
     *
     * @return self
     */
    public function setBackgroundColor($backgroundColor)
    {
        $this->container['backgroundColor'] = $backgroundColor;

        return $this;
    }

    /**
     * Gets fontColor
     *
     * @return string|null
     */
    public function getFontColor()
    {
        return $this->container['fontColor'];
    }

    /**
     * Sets fontColor
     *
     * @param string|null $fontColor font color of the tag (in hex, for example FF0000 - max. 6 chars!)
     *
     * @return self
     */
    public function setFontColor($fontColor)
    {
        $this->container['fontColor'] = $fontColor;

        return $this;
    }

    /**
     * Gets description
     *
     * @return string|null
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     *
     * @param string|null $description description of the tag (optional)
     *
     * @return self
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets image
     *
     * @return string|null
     */
    public function getImage()
    {
        return $this->container['image'];
    }

    /**
     * Sets image
     *
     * @param string|null $image name of image (optional)
     *
     * @return self
     */
    public function setImage($image)
    {
        $this->container['image'] = $image;

        return $this;
    }

    /**
     * Gets groupTagId
     *
     * @return int|null
     */
    public function getGroupTagId()
    {
        return $this->container['groupTagId'];
    }

    /**
     * Sets groupTagId
     *
     * @param int|null $groupTagId id of the group tag
     *
     * @return self
     */
    public function setGroupTagId($groupTagId)
    {
        $this->container['groupTagId'] = $groupTagId;

        return $this;
    }

    /**
     * Gets groupTag
     *
     * @return object|null
     */
    public function getGroupTag()
    {
        return $this->container['groupTag'];
    }

    /**
     * Sets groupTag
     *
     * @param object|null $groupTag groupTag
     *
     * @return self
     */
    public function setGroupTag($groupTag)
    {
        $this->container['groupTag'] = $groupTag;

        return $this;
    }

    /**
     * Gets groupTagInheritance
     *
     * @return bool|null
     */
    public function getGroupTagInheritance()
    {
        return $this->container['groupTagInheritance'];
    }

    /**
     * Sets groupTagInheritance
     *
     * @param bool|null $groupTagInheritance inherit visibilities from group tag
     *
     * @return self
     */
    public function setGroupTagInheritance($groupTagInheritance)
    {
        $this->container['groupTagInheritance'] = $groupTagInheritance;

        return $this;
    }

    /**
     * Gets isGroupParent
     *
     * @return bool|null
     */
    public function getIsGroupParent()
    {
        return $this->container['isGroupParent'];
    }

    /**
     * Sets isGroupParent
     *
     * @param bool|null $isGroupParent is the tag a parent for other tags
     *
     * @return self
     */
    public function setIsGroupParent($isGroupParent)
    {
        $this->container['isGroupParent'] = $isGroupParent;

        return $this;
    }

    /**
     * Gets visibilities
     *
     * @return object[]|null
     */
    public function getVisibilities()
    {
        return $this->container['visibilities'];
    }

    /**
     * Sets visibilities
     *
     * @param object[]|null $visibilities visibility assignments (departments, employees, company categories, ticket types)
     *
     * @return self
     */
    public function setVisibilities($visibilities)
    {
        $this->container['visibilities'] = $visibilities;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


